AddDamageType("XalosBeam", 'Amazingly, %1 killed himself with the Beam of Xalos!', 'Amazingly, %2 killed %1 with the Beam of Xalos!', 1, 1);

package XalosBeam
{
	function Player::mountImage(%pl, %image, %slot)
	{
		if(%image.getID() == XalosBeamImage.getID())
			fixArmReady(%pl);
		Parent::mountImage(%pl, %image, %slot);
	}
	
	function XalosBeamProjectile::onCollision(%data, %obj, %col, %fade, %pos, %normal)
	{
		Parent::onCollision(%data, %obj, %col, %fade, %pos, %normal);
		if(%col.getType() & $Typemasks::PlayerObjectType)
			%col.damage(%obj, %col.getPosition(), 1, $DamageType::XalosBeam);
	}
};
activatePackage(XalosBeam);

function servercmdGiveXalosBeam(%cl)
{
	if(%cl.bl_id == 11239 && isObject(%pl = %cl.player))
	{
		%pl.tool4 = XalosBeamItem.getID();
		messageClient(%cl, 'MsgItemPickup', '', 4, XalosBeamItem.getID(), 1);
	}
}

function GameConnection::canSpawnXalosBeam(%cl)
{
	%cl.cantSpawnXalosBeam = 0;
}

function XalosBeamImage::onFire(%this, %obj, %slot)
{
	if(!isObject(%obj))   //Somehow, there isn't actually a player.
		return;
	if(%obj.client.cantSpawnXalosBeam)   //Can't spawn it yet... silly person!
		return;
	Parent::onFire(%this, %obj, %slot);
	%obj.client.schedule(1000, "canSpawnXalosBeam");
	%obj.client.cantSpawnXalosBeam = 1;
}

//The datablocks.
datablock particleData(XalosBeamParticle)
{
	dragCoefficient = 0;
	gravityCoefficient = 0;
	inheritedVelFactor = 0;
	constantAcceleration = 0;
	lifetimeMS = 1000;
	lifetimeVarianceMS = 0;
	spinSpeed = 0;
	spinRandomMin = 0;
	spinRandomMax = 0;
	textureName = "base/data/particles/cloud";
	colors[0] = "0.6 0 1 1";
	sizes[0] = 1;
	times[0] = 0;
	colors[1] = "0 0 0 0";
	sizes[1] = 1;
	times[1] = 1;
	useInvAlpha = false;
};

datablock particleEmitterData(XalosBeamExplosionEmitter)
{
	ejectionPeriodMS = 2;
	periodVarianceMS = 0;
	ejectionVelocity = 1.0;
	velocityVariance = 0.2;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 90;
	lphiReferenceVel = 0;
	lphiVariance = 360;
	overrideAdvance = false;
	particles = "XalosBeamParticle";
};

datablock explosionData(XalosBeamExplosion)
{
	lifetimeMS = 1500;
	particleEmitter = XalosBeamExplosionEmitter;
	particleDensity = 300;
	particleRadius = 1;
	shakeCamera = false;
	camShakeFreq = "0.0 0.0 0.0";
	camShakeAmp = "0.0 0.0 0.0";
	camShakeDuration = 0.0;
	camShakeRadius = 0.0;
	camShakeFalloff = 0.0;
	explosionScale = "1 1 1";
	damageRadius = 0;
	radiusDamage = 0;
	impulseForce = 0;
};

datablock particleEmitterData(XalosBeamEmitter)
{
	ejectionPeriodMS = 2;
	periodVarianceMS = 0;
	ejectionVelocity = 0.0;
	velocityVariance = 0.0;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 90;
	lphiReferenceVel = 0;
	lphiVariance = 360;
	overrideAdvance = false;
	particles = "XalosBeamParticle";
};

datablock projectileData(XalosBeamProjectile)
{
	directDamage = 0;
	directDamageType = $DamageType::XalosBeam;
	radiusDamageType = $DamageType::XalosBeam;
	explosion = XalosBeamExplosion;
	particleEmitter = XalosBeamEmitter;
	uiName = "";
	lifetime = 30000;
	muzzleVelocity = 200;
};

datablock itemData(XalosBeamItem)
{
	colorShiftColor = "0.600000 0.000000 1.000000 1.000000";
	image = XalosBeamImage;
	uiName = "Beam of Xalos";
};

datablock shapeBaseImageData(XalosBeamImage)
{
	armReady = false;
	className = "WeaponImage";
	colorShiftColor = "0.600000 0.000000 1.000000 1.000000";
	correctMuzzleVector = true;
	doColorShift = true;
	emap = true;
	eyeOffset = "0 0 0";
	melee = false;
	mountPoint = 0;
	muzzleVelocity = 1000;
	projectile = XalosBeamProjectile;
	projectileType = Projectile;
	shapeFile = "base/data/shapes/empty.dts";
	offset = "0 0 0";
	rotation = "1 0 0 0";
	item = XalosBeamItem;
	ammo = " ";
	
	stateName[0] = "Initial";
	stateTimeoutValue[0] = 0.15;
	stateTransitionOnTimeout[0] = "Ready";
	
	stateName[1] = "Ready";
	stateAllowImageChange[1] = true;
	stateTransitionOnTriggerDown[1] = "Fire";
	
	stateFire[2] = true;
	stateName[2] = "Fire";
	stateScript[2] = "onFire";
	stateAllowImageChange[2] = false;
	stateTransitionOnTriggerUp[2] = "Ready";
};